local babble = LibStub("LibBabble-SubZone-3.0"):GetLookupTable()
local zonebabble = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
hooksecurefunc(ExtendedUI["CAPTUREPOINT"], "update", function(_, value)
	local subtext = GetSubZoneText()
	if subtext == babble["Ironclad Garrison"] then
		SendAddonMessage("TBBars", "1|"..(100-value), "RAID")
	elseif subtext == babble["Slagworks"] then
		SendAddonMessage("TBBars", "2|"..(100-value), "RAID")
	elseif subtext == babble["Warden's Vigil"] then
		SendAddonMessage("TBBars", "3|"..(100-value), "RAID")
	end
end)

local addon = CreateFrame("Frame", "TBBars", UIParent)
if GetRealZoneText() == zonebabble["Tol Barad"] then
	addon:Show()
else
	addon:Hide()
end
addon:SetSize(170,90)
addon.tex = addon:CreateTexture()
addon.tex:SetAllPoints()
addon.tex:SetTexture(0.6,0.6,0.6)
addon.tex:SetAlpha(0.2)
for i=1, 3 do
	local f = CreateFrame("Frame", nil, addon)
	f:SetSize(150, 15)
	if i==1 then
		f:SetPoint("TOPLEFT", 10, -10)
	elseif i==2 then
		f:SetPoint("LEFT", 10, 0)
	else
		f:SetPoint("BOTTOMLEFT", 10, 10)
	end
	f.tex = f:CreateTexture(nil, "BACKGROUND")
	f.tex:SetAllPoints()
	f.tex:SetTexture(0.5,0.5,0.5)
	f.tex:SetAlpha(0.8)
	f.left = f:CreateTexture(nil, "ARTWORK")
	f.left:SetPoint("TOPLEFT")
	f.left:SetPoint("BOTTOMLEFT")
	f.left:SetWidth(60)
	f.left:SetTexture(0, 100/255, 184/255)
	f.left:SetAlpha(0.7)
	f.right = f:CreateTexture(nil, "ARTWORK")
	f.right:SetPoint("TOPRIGHT")
	f.right:SetPoint("BOTTOMRIGHT")
	f.right:SetWidth(60)
	f.right:SetTexture(163/255, 56/255, 0)
	f.right:SetAlpha(0.7)
	f.text = f:CreateFontString(nil, "ARTWORK")
	f.text:SetPoint("CENTER")
	f.text:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
	f.text:SetTextColor(1,1,1)
	f.overlay = f:CreateTexture(nil, "OVERLAY")
	f.overlay:SetTexture(1,1,1)
	f.overlay:SetSize(5, 20)
	f.overlay:Hide()
	function f:SetState(i)
		f.overlay:Show()
		f.overlay:SetPoint("CENTER", f, "LEFT", (i/100)*f:GetWidth(), 0)
	end
	if i==1 then
		f.text:SetText(babble["Ironclad Garrison"])
	elseif i == 2 then
		f.text:SetText(babble["Slagworks"])
	else
		f.text:SetText(babble["Warden's Vigil"])
	end
	addon["bar"..i] = f
end
addon:SetScript("OnShow", function(self)
	self.bar1.overlay:Hide()
	self.bar2.overlay:Hide()
	self.bar3.overlay:Hide()
end)
addon:SetMovable(true)
addon:EnableMouse(true)
addon:SetScript("OnMouseDown", function(self)
	self:StartMoving()
end)
addon:SetScript("OnMouseUp", function(self)
	self:StopMovingOrSizing()
	local t=TBBarsPosition
	t.p, _, t.r, t.x, t.y = self:GetPoint()
end)
addon:SetScript("OnEvent", function(self, event, pre, msg)
	if (event == "CHAT_MSG_ADDON") and (pre == "TBBars") then
		local base, state = msg:match("(%d+)|(%d+)")
		base, state = tonumber(base), tonumber(state)
		addon["bar"..base]:SetState(state)
	elseif (event == "ADDON_LOADED") and (pre == "TBBars") then
		TBBarsPosition = TBBarsPosition or {p="CENTER",r="CENTER",x=0,y=0}
		addon:SetPoint(TBBarsPosition.p, nil, TBBarsPosition.r, TBBarsPosition.x, TBBarsPosition.y)
	elseif (event == "ZONE_CHANGED_NEW_AREA") then
		if GetRealZoneText() == zonebabble["Tol Barad"] then
			addon:Show()
		else
			addon:Hide()
		end
	end
end)
addon:RegisterEvent("CHAT_MSG_ADDON")
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("ZONE_CHANGED_NEW_AREA")
RegisterAddonMessagePrefix("TBBars")